## srpc 0.10.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")
set(CMAKE_SKIP_RPATH TRUE)

project(srpc
	VERSION 0.10.0
	LANGUAGES C CXX)
	
###Options

if (WIN32)
	option(SRPC_BUILD_STATIC_RUNTIME "Use static runtime" ON)
endif ()

#### CHECK

include(CheckIncludeFile)
include(CheckIncludeFileCXX)

find_library(LZ4_LIBRARY NAMES lz4)
check_include_file("lz4.h" LZ4_INSTALLED)
if (NOT LZ4_INSTALLED AND ${LZ4_LIBRARY} STREQUAL "LZ4_LIBRARY-NOTFOUND")
	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
		message( FATAL_ERROR "Lz4 is neither installed not in third_party!")
	endif ()
else ()
	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
		message("Lz4 third_party FOUND. Use for source code dependencies.")
		set(LZ4_INSTALLED 0 CACHE INTERNAL "check_lz4_installed")
	else ()
		find_path(LZ4_INCLUDE_DIR NAMES "lz4.h")
		include_directories(${LZ4_INCLUDE_DIR})
		set(LZ4_INSTALLED 1 CACHE INTERNAL "check_lz4_installed")
	endif ()
endif ()

find_package(Snappy)
check_include_file_cxx("snappy.h" SNAPPY_INSTALLED)
if (NOT SNAPPY_INSTALLED AND NOT ${Snappy_FOUND})
	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
		message( FATAL_ERROR "Snappy is neither installed not in third_party!")
	endif ()
else ()
	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
		message("Snappy third_party FOUND. Use for source code dependencies.")
		set(SNAPPY_INSTALLED 0 CACHE INTERNAL "check_snappy_installed")
	else ()
		find_path(Snappy_INCLUDE_DIR NAMES "snappy.h")
		include_directories(${Snappy_INCLUDE_DIR})
		set(SNAPPY_INSTALLED 1 CACHE INTERNAL "check_snappy_installed")
	endif ()
endif ()

check_include_file_cxx("workflow/Workflow.h" WORKFLOW_INSTALLED)
if (NOT WORKFLOW_INSTALLED)
	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
		message( FATAL_ERROR "Workflow is neither installed not in third_party!")
	endif ()
else ()
	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
		message("Workflow third_party FOUND. Use for source code dependencies.")
		set(WORKFLOW_INSTALLED 0)
	endif ()
endif ()

find_program(PROTOC "protoc")
if(${PROTOC} STREQUAL "PROTOC-NOTFOUND")
    message( FATAL_ERROR "Protobuf compiler is missing!")
endif()

#### PREPARE

set(INC_DIR ${PROJECT_SOURCE_DIR}/_include CACHE PATH "srpc inc")
set(LIB_DIR ${PROJECT_SOURCE_DIR}/_lib CACHE PATH "srpc lib")
set(BIN_DIR ${PROJECT_SOURCE_DIR}/_bin CACHE PATH "srpc bin")

include(GNUInstallDirs)

set(CMAKE_CONFIG_INSTALL_FILE ${PROJECT_BINARY_DIR}/config.toinstall.cmake)
set(CMAKE_CONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIB_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIB_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BIN_DIR})

add_custom_target(
	LINK_HEADERS ALL
	COMMENT "link headers..."
)

INCLUDE(CMakeLists_Headers.txt)

macro(makeLink src dest target)
	add_custom_command(
		TARGET ${target} PRE_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dest}
		DEPENDS ${dest}
	)
endmacro()

add_custom_command(
	TARGET LINK_HEADERS PRE_BUILD
	COMMAND ${CMAKE_COMMAND} -E make_directory ${INC_DIR}/${PROJECT_NAME}
)

foreach(header_file ${INCLUDE_HEADERS})
	string(REPLACE "/" ";" arr ${header_file})
	list(GET arr -1 file_name)
	makeLink(${PROJECT_SOURCE_DIR}/${header_file} ${INC_DIR}/${PROJECT_NAME}/${file_name} LINK_HEADERS)
endforeach()

if (WIN32)
	if (SRPC_BUILD_STATIC_RUNTIME)
		set(CompilerFlags
				CMAKE_CXX_FLAGS
				CMAKE_CXX_FLAGS_DEBUG
				CMAKE_CXX_FLAGS_RELEASE
				CMAKE_CXX_FLAGS_MINSIZEREL
				CMAKE_C_FLAGS
				CMAKE_C_FLAGS_DEBUG
				CMAKE_C_FLAGS_RELEASE
				CMAKE_C_FLAGS_MINSIZEREL
				)
		foreach(CompilerFlag ${CompilerFlags})
			string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
		endforeach ()
	endif ()
endif ()

add_subdirectory(src)

#### CONFIG

include(CMakePackageConfigHelpers)
set(CONFIG_INC_DIR ${INC_DIR})
set(CONFIG_LIB_DIR ${LIB_DIR})

if (VCPKG_TOOLCHAIN AND EXISTS "${CMAKE_INSTALL_PREFIX}/tools/srpc")
	set(CONFIG_BIN_DIR ${CMAKE_INSTALL_PREFIX}/tools/srpc)
	set(WITH_VCPKG_TOOLCHAIN 1 CACHE INTERNAL "build_with_vcpkg_toolchain")
	message("Install with VCPKG toolchain. Dir ${CMAKE_INSTALL_PREFIX}/tools/srpc.")
else()
	set(CONFIG_BIN_DIR ${BIN_DIR})
	set(WITH_VCPKG_TOOLCHAIN 0 CACHE INTERNAL "build_with_vcpkg_toolchain")
endif()

configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${PROJECT_SOURCE_DIR}/${PROJECT_NAME}-config.cmake
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR CONFIG_BIN_DIR
)

set(CONFIG_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(CONFIG_LIB_DIR ${CMAKE_INSTALL_LIBDIR})
set(CONFIG_BIN_DIR ${CMAKE_INSTALL_BINDIR})
configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${CMAKE_CONFIG_INSTALL_FILE}
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR CONFIG_BIN_DIR
)

write_basic_package_version_file(
	${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
	VERSION ${WORKFLOW_VERSION}
	COMPATIBILITY AnyNewerVersion
)

install(
	FILES ${CMAKE_CONFIG_INSTALL_FILE}
	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	COMPONENT devel
	RENAME ${PROJECT_NAME}-config.cmake
)

install(
	FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	COMPONENT devel
)

install(
	FILES ${INCLUDE_HEADERS}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
	COMPONENT devel
)

install(
	FILES README.md
	DESTINATION "${CMAKE_INSTALL_DOCDIR}-${PROJECT_VERSION}"
	COMPONENT devel
)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf REQUIRED CONFIG)
else ()
	find_package(Protobuf 3.5.0 REQUIRED)
endif ()

if (WIN32)
	set (HAVE_SYS_UIO_H_01 false)
else ()
	set (HAVE_SYS_UIO_H_01 true)
endif ()

if (WITH_VCPKG_TOOLCHAIN)
	find_package(Workflow REQUIRED CONFIG)
else ()
	# Try to find the package if workflow is nor installed, otherwise proceed with find_package()
	if (NOT WORKFLOW_INSTALLED)
		find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
	endif ()

	if (NOT SNAPPY_INSTALLED)
		set(SNAPPY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy)
		configure_file(${SNAPPY_DIR}/cmake/config.h.in ${SNAPPY_DIR}/config.h)
		configure_file(${SNAPPY_DIR}/snappy-stubs-public.h.in ${SNAPPY_DIR}/snappy-stubs-public.h)
	else ()
		find_package(Snappy 1.1.6 REQUIRED CONFIG)
		set(SNAPPY_LIB snappy)
	endif ()

	if (LZ4_INSTALLED)
		set(LZ4_LIB lz4)
	endif ()
endif()

include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}
	${Protobuf_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
	${INC_DIR}/srpc
)

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

add_subdirectory(generator)

set(SRC
	rpc_buffer.cc
	rpc_basic.cc
	rpc_global.cc
)

add_subdirectory(module)
add_subdirectory(var)
add_subdirectory(thrift)
add_subdirectory(compress)
add_subdirectory(message)

add_dependencies(module LINK_HEADERS)
add_dependencies(var LINK_HEADERS)
add_dependencies(thrift LINK_HEADERS)
add_dependencies(compress LINK_HEADERS)
add_dependencies(message LINK_HEADERS)


if (WIN32)
	add_library(
		${PROJECT_NAME} STATIC
		${SRC}
		$<TARGET_OBJECTS:module>
		$<TARGET_OBJECTS:var>
		$<TARGET_OBJECTS:thrift>
		$<TARGET_OBJECTS:compress>
		$<TARGET_OBJECTS:message>
	)

	add_dependencies(${PROJECT_NAME} LINK_HEADERS)

	target_compile_definitions(
		${PROJECT_NAME} PRIVATE
		strdup=_strdup
		strcasecmp=_stricmp
		strncasecmp=_strnicmp
	)

	install(
		TARGETS ${PROJECT_NAME}
		ARCHIVE
		DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)

else ()
	set(STATIC_LIB_NAME ${PROJECT_NAME}-static)
	set(SHARED_LIB_NAME ${PROJECT_NAME}-shared)
	link_directories(${OPENSSL_LINK_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})

	add_library(
		${STATIC_LIB_NAME} STATIC
		${SRC}
		$<TARGET_OBJECTS:module>
		$<TARGET_OBJECTS:var>
		$<TARGET_OBJECTS:thrift>
		$<TARGET_OBJECTS:compress>
		$<TARGET_OBJECTS:message>
	)

	add_library(
		${SHARED_LIB_NAME} SHARED
		${SRC}
		$<TARGET_OBJECTS:module>
		$<TARGET_OBJECTS:var>
		$<TARGET_OBJECTS:thrift>
		$<TARGET_OBJECTS:compress>
		$<TARGET_OBJECTS:message>
	)

	target_link_libraries(${SHARED_LIB_NAME} 
						  OpenSSL::SSL
						  OpenSSL::Crypto
						  pthread
						  protobuf
						  workflow
						  z ${SNAPPY_LIB} ${LZ4_LIB})
		
	set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR} )

	add_dependencies(${STATIC_LIB_NAME} LINK_HEADERS)
	add_dependencies(${SHARED_LIB_NAME} LINK_HEADERS)

	install(
		TARGETS ${STATIC_LIB_NAME}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)

	install(
		TARGETS ${SHARED_LIB_NAME}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)

endif ()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(srpc_test
		LANGUAGES C CXX
)

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)
find_package(srpc REQUIRED CONFIG HINTS ..)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf CONFIG REQUIRED)
else ()
	find_package(Protobuf REQUIRED)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/lz4/lib/lz4.h")
	set(LZ4_LIB lz4)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake")
	set(SNAPPY_LIB snappy)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
	find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
endif ()

include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${Protobuf_INCLUDE_DIR}
	${SRPC_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
)

if (WIN32)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/Debug/srpc_generator.exe)
else ()
	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/srpc_generator)
endif ()

find_program(CMAKE_MEMORYCHECK_COMMAND valgrind)
set(memcheck_command ${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1 --leak-check=full --show-leak-kinds=all)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

enable_testing()

if (WIN32)
	find_package(GTest CONFIG REQUIRED)
else ()
	find_package(GTest REQUIRED)
endif ()

set(CXX_STD "c++11")
if (GTest_VERSION VERSION_GREATER_EQUAL "1.13.0")
	set(CXX_STD "c++14")
else ()
	get_filename_component(GTEST_PATH ${GTEST_LIBRARY} DIRECTORY ABSOLUTE)
	execute_process(COMMAND grep Version "${GTEST_PATH}/pkgconfig/gtest.pc"
					RESULT_VARIABLE GTEST_VERSION_RESULT
					OUTPUT_VARIABLE GTEST_VERSION_OUTPUT)
	if (${GTEST_VERSION_RESULT} EQUAL "0")
		string(REPLACE " " ";" GTEST_VERSION_STR ${GTEST_VERSION_OUTPUT})
		list(GET GTEST_VERSION_STR 1 GTEST_VERSION)
		if (${GTEST_VERSION} VERSION_GREATER_EQUAL "1.13.0")
			set(CXX_STD "c++14")
		endif ()
	endif ()
endif ()

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=${CXX_STD} -fno-exceptions")
endif ()

set(TEST_LIST
	unittest
)

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS test_pb.proto)

add_custom_target(
	SRPC_GEN ALL
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/test_pb.proto ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/test_thrift.thrift ${PROJECT_SOURCE_DIR}
	COMMENT "srpc generator..."
)

set(GTEST_LIB GTest::GTest GTest::Main)

if (APPLE)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ${CMAKE_FIND_LIBRARY_SUFFIXES})
	find_library(Workflow_LIB workflow HINTS ../workflow/_lib)
	find_library(Srpc_LIB srpc HINTS ../_lib)

	set(SRPC_LIB
		${Srpc_LIB}
		${Workflow_LIB}
		pthread
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf
		z
		)
elseif (WIN32)
	set(SRPC_LIB
		srpc
		workflow
		ws2_32
		wsock32
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf::libprotobuf
		ZLIB::ZLIB
		Snappy::snappy
		${LZ4_LIBRARY}
		)
	set(GTEST_LIB GTest::gtest GTest::gtest_main)
else ()
	if (SNAPPY_INSTALLED)
		set(SNAPPY_LIB snappy)
	endif ()

	if (LZ4_INSTALLED)
		set(LZ4_LIB lz4)
	endif ()

	set(SRPC_LIB
		srpc
		workflow
		pthread
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf
		z
		${SNAPPY_LIB}
		${LZ4_LIB}
		)
endif ()

foreach(src ${TEST_LIST})
	add_executable(${src} EXCLUDE_FROM_ALL ${src}.cc ${PROTO_SRCS} ${PROTO_HDRS})
	target_link_libraries(${src} ${SRPC_LIB} ${GTEST_LIB})
	add_test(${src} ${src})
	add_dependencies(${src} SRPC_GEN)
	add_dependencies(check ${src})
endforeach()

if (WIN32)
	set(memcheck nothing)
elseif (NOT ${CMAKE_MEMORYCHECK_COMMAND} STREQUAL "CMAKE_MEMORYCHECK_COMMAND-NOTFOUND")
	foreach(src ${TEST_LIST})
		add_test(${src}-memory-check ${memcheck_command} ./${src})
	endforeach()
endif ()

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

project(srpc-ctl
		VERSION 0.10.0
		LANGUAGES C CXX
)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_BUILD_TYPE RelWithDebInfo)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

set(generator_code
	"../src/generator/generator.cc"
	"../src/generator/parser.cc")

set(srpc_ctl_code
	"srpc_ctl.cc"
	"srpc_config.cc"
	"srpc_controller.cc"
	"srpc_basic_controller.cc"
	"srpc_rpc_controller.cc"
	"srpc_proxy_controller.cc")

include_directories("../src/")
add_executable(srpc ${srpc_ctl_code} ${generator_code})
target_link_libraries(srpc ${LIBRARY_NAME})

=== tutorial/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(srpc_tutorial
		LANGUAGES C CXX
)

###Options

if (WIN32)
	option(SRPC_TUTORIAL_BUILD_STATIC_RUNTIME "Use static runtime" ON)
endif ()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)
find_package(srpc REQUIRED CONFIG HINTS ..)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf CONFIG REQUIRED)
	find_library(LZ4_LIBRARY NAMES lz4)
	if(LZ4_LIBRARY STREQUAL "LZ4_LIBRARY-NOTFOUND")
		find_package(lz4)
		if(lz4_FOUND)
			set(LZ4_LIBRARY ${lz4_LIBRARIES})
		endif()
	endif()
	find_package(Snappy CONFIG REQUIRED)
else ()
	find_package(Protobuf REQUIRED)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/lz4/lib/lz4.h")
	set(LZ4_LIB lz4)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake")
	set(SNAPPY_LIB snappy)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
	find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
endif ()

find_package(ZLIB REQUIRED)

include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${Protobuf_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
	${SRPC_INCLUDE_DIR}
)

if (WIN32)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/Debug/srpc_generator.exe)
else ()
	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/srpc_generator)
endif ()

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS echo_pb.proto)
protobuf_generate_cpp(HELLOWORLD_SRCS HELLOWORLD_HDRS helloworld.proto)

add_custom_target(
	TURORIAL_GEN ALL
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_pb.proto  ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_thrift.thrift ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} protobuf ${PROJECT_SOURCE_DIR}/helloworld.proto ${PROJECT_SOURCE_DIR}
	COMMENT "srpc generator..."
)

if (WIN32)
	if (SRPC_TUTORIAL_BUILD_STATIC_RUNTIME)
		set(CompilerFlags
				CMAKE_CXX_FLAGS
				CMAKE_CXX_FLAGS_DEBUG
				CMAKE_CXX_FLAGS_RELEASE
				CMAKE_CXX_FLAGS_MINSIZEREL
				CMAKE_C_FLAGS
				CMAKE_C_FLAGS_DEBUG
				CMAKE_C_FLAGS_RELEASE
				CMAKE_C_FLAGS_MINSIZEREL
				)
		foreach(CompilerFlag ${CompilerFlags})
			string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
		endforeach ()
	endif ()
endif ()

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

set(TUTORIAL_PB_LIST
	tutorial-01-srpc_pb_server
	tutorial-02-srpc_pb_client
	tutorial-05-brpc_pb_server
	tutorial-06-brpc_pb_client
	tutorial-09-client_task
	tutorial-10-server_async
	tutorial-15-srpc_pb_proxy
	tutorial-16-server_with_metrics
)

if (APPLE)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ${CMAKE_FIND_LIBRARY_SUFFIXES})
	find_library(Workflow_LIB workflow HINTS ../workflow/_lib)
	find_library(Srpc_LIB srpc HINTS ../_lib)

	set(SRPC_LIB
		${Srpc_LIB}
		${Workflow_LIB}
		pthread
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf
		z
		)
elseif (WIN32)
	set(SRPC_LIB
		srpc
		workflow
		ws2_32
		wsock32
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf::libprotobuf
		ZLIB::ZLIB
		Snappy::snappy
		${LZ4_LIBRARY}
		)
else ()
	set(SRPC_LIB
		srpc
		workflow
		pthread
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf
		z
		${SNAPPY_LIB}
		${LZ4_LIB}
		)
endif ()

foreach(src ${TUTORIAL_PB_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc ${PROTO_SRCS} ${PROTO_HDRS})
	target_link_libraries(${bin_name} ${SRPC_LIB})
	add_dependencies(${bin_name} TURORIAL_GEN)
endforeach()

set(TUTORIAL_THRIFT_LIST
	tutorial-03-srpc_thrift_server
	tutorial-04-srpc_thrift_client
	tutorial-07-thrift_thrift_server
	tutorial-08-thrift_thrift_client
)

foreach(src ${TUTORIAL_THRIFT_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${SRPC_LIB})
	add_dependencies(${bin_name} TURORIAL_GEN)
endforeach()

set(TUTORIAL_HELLOWORLD_LIST
	tutorial-11-trpc_pb_server
	tutorial-12-trpc_pb_client
	tutorial-13-trpc_http_server
	tutorial-14-trpc_http_client
)

foreach(src ${TUTORIAL_HELLOWORLD_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc ${HELLOWORLD_SRCS} ${HELLOWORLD_HDRS})
	target_link_libraries(${bin_name} ${SRPC_LIB})
	add_dependencies(${bin_name} TURORIAL_GEN)
endforeach()

=== src/module/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(module)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(PROTO_LIST
	proto/opentelemetry_common.proto
	proto/opentelemetry_resource.proto
	proto/opentelemetry_trace.proto
	proto/opentelemetry_trace_service.proto
	proto/opentelemetry_metrics.proto
	proto/opentelemetry_metrics_service.proto)

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS ${PROTO_LIST})

set(SRC
	rpc_module.cc
	rpc_trace_filter.cc
	rpc_metrics_filter.cc
	${PROTO_SRCS} ${PROTO_HDRS}
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== debian/changelog ===
srpc (0.10.0-2) unstable; urgency=medium

  * d/clean: Remove autogenerated files (Closes: #1046697)
  * d/upstream/metadata: Add upstream metadata

 -- Lance Lin <lq27267@gmail.com>  Wed, 16 Aug 2023 19:21:21 +0700

srpc (0.10.0-1) unstable; urgency=medium

  * Update to new version (0.10.0)
  * d/patches: refresh remove-tutorial-check-targets.patch
  * d/libsrpc0.install: Use wildcard for version number

 -- Lance Lin <lq27267@gmail.com>  Tue, 30 May 2023 23:45:27 +0700

## srpc 0.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.10.0
+	VERSION 0.10.1
 	LANGUAGES C CXX)
 	
 ###Options
@@ -17,11 +17,17 @@
 include(CheckIncludeFile)
 include(CheckIncludeFileCXX)
 
+set(THIRD_PARTY_FATAL_MESSAGE
+" is neither installed nor found in third_party!
+Sugguestion to initial third_party:
+	\"git submodule update --init\""
+)
+
 find_library(LZ4_LIBRARY NAMES lz4)
 check_include_file("lz4.h" LZ4_INSTALLED)
 if (NOT LZ4_INSTALLED AND ${LZ4_LIBRARY} STREQUAL "LZ4_LIBRARY-NOTFOUND")
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
-		message( FATAL_ERROR "Lz4 is neither installed not in third_party!")
+		message( FATAL_ERROR "\nLz4" ${THIRD_PARTY_FATAL_MESSAGE} )
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
@@ -38,7 +44,7 @@
 check_include_file_cxx("snappy.h" SNAPPY_INSTALLED)
 if (NOT SNAPPY_INSTALLED AND NOT ${Snappy_FOUND})
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
-		message( FATAL_ERROR "Snappy is neither installed not in third_party!")
+		message( FATAL_ERROR "\nSnappy" ${THIRD_PARTY_FATAL_MESSAGE} )
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
@@ -54,7 +60,7 @@
 check_include_file_cxx("workflow/Workflow.h" WORKFLOW_INSTALLED)
 if (NOT WORKFLOW_INSTALLED)
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
-		message( FATAL_ERROR "Workflow is neither installed not in third_party!")
+		message( FATAL_ERROR "\nWorkflow" ${THIRD_PARTY_FATAL_MESSAGE} )
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")

=== benchmark/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(srpc_benchmark
		LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf CONFIG REQUIRED)
	find_library(LZ4_LIBRARY NAMES lz4)
	find_package(Snappy CONFIG REQUIRED)
else ()
	find_package(Protobuf REQUIRED)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/lz4/lib/lz4.h")
	set(LZ4_LIB lz4)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake")
	set(SNAPPY_LIB snappy)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
	find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
endif ()

find_package(srpc REQUIRED CONFIG HINTS ..)
include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${Protobuf_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
	${SRPC_INCLUDE_DIR}
)

if (WIN32)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/Debug/srpc_generator.exe)
else ()
	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/srpc_generator)
endif ()

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS benchmark_pb.proto)

add_custom_target(
	BENCHMARK_GEN ALL
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/benchmark_pb.proto  ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/benchmark_thrift.thrift ${PROJECT_SOURCE_DIR}
	COMMENT "srpc generator..."
)

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

if (APPLE)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ${CMAKE_FIND_LIBRARY_SUFFIXES})
	find_library(Workflow_LIB workflow HINTS ../workflow/_lib)
	find_library(Srpc_LIB srpc HINTS ../_lib)

	set(SRPC_LIB
		${Srpc_LIB}
		${Workflow_LIB}
		pthread
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf
		z
		)
elseif (WIN32)
	set(SRPC_LIB
		srpc
		workflow
		ws2_32
		wsock32
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf::libprotobuf
		ZLIB::ZLIB
		Snappy::snappy
		${LZ4_LIBRARY}
		)
else ()
	set(SRPC_LIB
		srpc
		workflow
		pthread
		OpenSSL::SSL
		OpenSSL::Crypto
		protobuf
		z
		${SNAPPY_LIB}
		${LZ4_LIB}
		)
endif ()

add_executable(server server.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(server ${SRPC_LIB})
add_dependencies(server BENCHMARK_GEN)

add_executable(client client.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(client ${SRPC_LIB})
add_dependencies(client BENCHMARK_GEN)

add_executable(client_cdf client_cdf.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(client_cdf ${SRPC_LIB})
add_dependencies(client_cdf BENCHMARK_GEN)

add_executable(proxy proxy.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(proxy ${SRPC_LIB})
add_dependencies(proxy BENCHMARK_GEN)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.6)
 
 project(srpc-ctl
-		VERSION 0.10.0
+		VERSION 0.10.1
 		LANGUAGES C CXX
 )

=== src/compress/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(compress)

set(SRC
	rpc_compress.cc
	rpc_compress_snappy.cc
)

set_property(SOURCE rpc_compress_snappy.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")

if (WITH_VCPKG_TOOLCHAIN)
	add_library(${PROJECT_NAME} OBJECT ${SRC})
	target_link_libraries(${PROJECT_NAME} lz4 snappy)
else ()
	if (SNAPPY_INSTALLED)
		set(SNAPPY_LIB snappy)
	else ()
		set(SNAPPY_SRC
			../../third_party/snappy/config.h
			../../third_party/snappy/snappy-internal.h
			../../third_party/snappy/snappy-sinksource.cc
			../../third_party/snappy/snappy-sinksource.h
			../../third_party/snappy/snappy-stubs-internal.cc
			../../third_party/snappy/snappy-stubs-internal.h
			../../third_party/snappy/snappy-stubs-public.h
			../../third_party/snappy/snappy.cc
			../../third_party/snappy/snappy.h
			)
	endif ()

	if (LZ4_INSTALLED)
		set(LZ4_LIB lz4)
	else ()
		set(LZ4_SRC
			../../third_party/lz4/lib/lz4.c
			../../third_party/lz4/lib/lz4.h
			../../third_party/lz4/lib/lz4hc.h
			../../third_party/lz4/lib/lz4hc.c
			../../third_party/lz4/lib/lz4frame.h
			../../third_party/lz4/lib/lz4frame.c
			../../third_party/lz4/lib/xxhash.c
			../../third_party/lz4/lib/xxhash.h
			)
	endif ()

	add_library(
		${PROJECT_NAME} OBJECT
		${SRC}
		${SNAPPY_SRC}
		${LZ4_SRC}
	)
endif()

=== src/var/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(var)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(SRC
	rpc_var.cc
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== tools/templates/rpc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(%s LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_BUILD_TYPE RelWithDebInfo)

set(Protobuf_ERROR_MSG "ERROR: Failed to find protobuf. Some suggestions for installation.")
set(Protobuf_ERROR_MSG_LINUX "${Protobuf_ERROR_MSG}
For Debian / Ubuntu ...:
    sudo apt-get update
    sudo apt-get install -y libprotobuf-dev protobuf-compiler
For RedHat / Fedora / CentOS ...:
    sudo yum makecache
    sudo yum install -y protobuf-devel protobuf-compiler")

set(Protobuf_ERROR_MSG_MACOS "${Protobuf_ERROR_MSG}
For MacOS :
    sudo brew update
    sudo brew install protobuf protobuf-c")

# Find all the dependencies
find_package(OpenSSL REQUIRED)

set(Workflow_DIR "%s")
find_package(Workflow REQUIRED CONFIG HINTS ${Workflow_DIR})

set(Srpc_DIR "%s")
find_package(srpc REQUIRED CONFIG HINTS ${Srpc_DIR})

find_package(Protobuf)
if ("x${Protobuf_DIR}" STREQUAL "xProtobuf_DIR-NOTFOUND")
    if (APPLE)
        message (FATAL_ERROR ${Protobuf_ERROR_MSG_MACOS})
    else ()
        message (FATAL_ERROR ${Protobuf_ERROR_MSG_LINUX})
    endif ()
endif ()

get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)

if (NOT EXISTS "${Srpc_DIR}/third_party/lz4/lib/lz4.h")
    set(LZ4_LIB lz4)
endif ()

if (NOT EXISTS "${Srpc_DIR}/third_party/snappy/cmake")
    set(SNAPPY_LIB snappy)
endif ()

find_package(ZLIB REQUIRED)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

# Generate idl code: xx.srpc.h xx.pb.h xx.pb.cc xx.thrift.h
set(IDL_FILE %s)
set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/srpc_generator) %s

add_custom_target(SRPC_GEN ALL
    COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/${IDL_FILE} ${PROJECT_SOURCE_DIR} -s
    COMMENT "sprc generator..."
)

# Prefer to static link first
set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ${CMAKE_FIND_LIBRARY_SUFFIXES})
find_library(Workflow_LIB workflow HINTS ${Workflow_DIR}/_lib)
find_library(Srpc_LIB srpc HINTS ${Srpc_DIR}/_lib)

# Set all the libraries here
set(LIB ${Srpc_LIB} ${Workflow_LIB} pthread OpenSSL::SSL OpenSSL::Crypto
    protobuf z ${SNAPPY_LIB} ${LZ4_LIB})

# Add all the common code here
set(COMMON_CODE config/config.cc config/Json.cc ${PROTO_SRCS})

# Add header directories and library directories here
include_directories(${OPENSSL_INCLUDE_DIR} ${Protobuf_INCLUDE_DIR}
                    ${WORKFLOW_INCLUDE_DIR} ${SRPC_INCLUDE_DIR}
                    ${PROJECT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
link_directories(${OPENSSL_LINK_DIR} ${Protobuf_LIB_DIR}
                 ${WORKFLOW_LIB_DIR} ${SRPC_LIB_DIR})

# Build executable outputs
set(PROJECT_OUTPUT server client%s)
foreach(output ${PROJECT_OUTPUT})
    add_executable(${output} ${output}_main.cc ${COMMON_CODE})
    target_link_libraries(${output} ${LIB})
endforeach()

=== debian/changelog ===
srpc (0.10.1-1) unstable; urgency=medium

  * New upstream version
  * Reorder sequence of d/control fields by cme (routine-update)
  * d/patches: Update patch header to include missing fields

 -- Lance Lin <lq27267@gmail.com>  Mon, 08 Jan 2024 20:28:03 +0700

=== debian/control ===
Source: srpc
Maintainer: Lance Lin <lq27267@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libworkflow-dev,
               libssl-dev,
               libsnappy-dev,
               libprotobuf-dev,
               protobuf-compiler,
               liblz4-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/srpc
Vcs-Git: https://salsa.debian.org/debian/srpc.git
Homepage: https://github.com/sogou/srpc
Rules-Requires-Root: no

Package: libsrpc0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libsrpc (<< 0.9.7-1)
Replaces: libsrpc (<< 0.9.7-1)
Description: Sogou RPC (SRPC) Runtime Library
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the runtime library.

Package: libsrpc-dev
Architecture: any
Multi-Arch: same
Depends: libsrpc0 (= ${binary:Version}),
         libsrpc-bin (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libsrpc (<< 0.9.7-1)
Replaces: libsrpc (<< 0.9.7-1)
Description: Sogou RPC Library (SRPC)
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the development header files.

Package: libsrpc-bin
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libsrpc (<< 0.9.7-1)
Replaces: libsrpc (<< 0.9.7-1)
Description: Sogou RPC Library (SRPC) Generator
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the IDL file generator, srpc_generator

## srpc 0.10.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.10.1
+	VERSION 0.10.2
 	LANGUAGES C CXX)
 	
 ###Options

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -83,6 +83,10 @@
 add_dependencies(compress LINK_HEADERS)
 add_dependencies(message LINK_HEADERS)
 
+if (NOT WIN32)
+	add_subdirectory(http)
+	add_dependencies(http LINK_HEADERS)
+endif ()
 
 if (WIN32)
 	add_library(
@@ -114,6 +118,7 @@
 else ()
 	set(STATIC_LIB_NAME ${PROJECT_NAME}-static)
 	set(SHARED_LIB_NAME ${PROJECT_NAME}-shared)
+	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
 	link_directories(${OPENSSL_LINK_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
 
 	add_library(
@@ -124,6 +129,7 @@
 		$<TARGET_OBJECTS:thrift>
 		$<TARGET_OBJECTS:compress>
 		$<TARGET_OBJECTS:message>
+		$<TARGET_OBJECTS:http>
 	)
 
 	add_library(
@@ -134,16 +140,21 @@
 		$<TARGET_OBJECTS:thrift>
 		$<TARGET_OBJECTS:compress>
 		$<TARGET_OBJECTS:message>
+		$<TARGET_OBJECTS:http>
 	)
 
-	target_link_libraries(${SHARED_LIB_NAME} 
-						  OpenSSL::SSL
-						  OpenSSL::Crypto
-						  pthread
-						  protobuf
-						  workflow
-						  z ${SNAPPY_LIB} ${LZ4_LIB})
-		
+	if (APPLE)
+		target_link_libraries(${SHARED_LIB_NAME}
+							  OpenSSL::SSL
+							  OpenSSL::Crypto
+							  pthread
+							  ${Protobuf_LIBRARY}
+							  workflow
+							  z ${SNAPPY_LIB} ${LZ4_LIB})
+	else ()
+		target_link_libraries(${SHARED_LIB_NAME})
+	endif ()
+
 	set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
 	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR} )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -93,10 +93,6 @@
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=${CXX_STD} -fno-exceptions")
 endif ()
 
-set(TEST_LIST
-	unittest
-)
-
 protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS test_pb.proto)
 
 add_custom_target(
@@ -158,6 +154,10 @@
 		)
 endif ()
 
+set(TEST_LIST unittest)
+set(BASIC_TEST var_unittest)
+set(ALL_TEST var_unittest unittest)
+
 foreach(src ${TEST_LIST})
 	add_executable(${src} EXCLUDE_FROM_ALL ${src}.cc ${PROTO_SRCS} ${PROTO_HDRS})
 	target_link_libraries(${src} ${SRPC_LIB} ${GTEST_LIB})
@@ -166,10 +166,17 @@
 	add_dependencies(check ${src})
 endforeach()
 
+foreach(src ${BASIC_TEST})
+	add_executable(${src} EXCLUDE_FROM_ALL ${src}.cc)
+	target_link_libraries(${src} ${SRPC_LIB} ${GTEST_LIB})
+	add_test(${src} ${src})
+	add_dependencies(check ${src})
+endforeach()
+
 if (WIN32)
 	set(memcheck nothing)
 elseif (NOT ${CMAKE_MEMORYCHECK_COMMAND} STREQUAL "CMAKE_MEMORYCHECK_COMMAND-NOTFOUND")
-	foreach(src ${TEST_LIST})
+	foreach(src ${ALL_TEST})
 		add_test(${src}-memory-check ${memcheck_command} ./${src})
 	endforeach()
 endif ()

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.6)
 
 project(srpc-ctl
-		VERSION 0.10.1
+		VERSION 0.10.2
 		LANGUAGES C CXX
 )

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -200,3 +200,18 @@
 	add_dependencies(${bin_name} TURORIAL_GEN)
 endforeach()
 
+if (NOT WIN32)
+	set(TUTORIAL_HTTP_LIST
+		tutorial-17-http_server
+		tutorial-18-http_client
+	)
+
+	foreach(src ${TUTORIAL_HTTP_LIST})
+		string(REPLACE "-" ";" arr ${src})
+		list(GET arr -1 bin_name)
+		add_executable(${bin_name} ${src}.cc)
+		target_link_libraries(${bin_name} ${SRPC_LIB})
+		add_dependencies(${bin_name} TURORIAL_GEN)
+	endforeach()
+endif ()
+

=== src/generator/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(srpc_generator)

set(SRC
	compiler.cc
	generator.cc
	parser.cc
)

add_executable(${PROJECT_NAME} ${SRC})
if (WIN32)
	target_compile_definitions(
		${PROJECT_NAME} PRIVATE
		getcwd=_getcwd
		strdup=_strdup
		strcasecmp=_stricmp
		strncasecmp=_strnicmp
	)
endif ()

install(
	TARGETS ${PROJECT_NAME}
	RUNTIME
	DESTINATION ${CMAKE_INSTALL_BINDIR}
	COMPONENT devel
)

=== src/http/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(http)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(SRC
	http_module.cc
	http_task.cc
	http_client.cc
	http_server.cc
)

add_library(${PROJECT_NAME} OBJECT ${SRC})
if (WIN32)
	target_compile_definitions(
		${PROJECT_NAME} PRIVATE
		strdup=_strdup
		strcasecmp=_stricmp
		strncasecmp=_strnicmp
	)
endif ()

=== src/message/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(message)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(PROTO_LIST rpc_meta.proto rpc_meta_brpc.proto rpc_meta_trpc.proto)
protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS ${PROTO_LIST})

set(SRC
	rpc_message_brpc.cc
	rpc_message_srpc.cc
	rpc_message_thrift.cc
	rpc_message_trpc.cc
	${PROTO_SRCS} ${PROTO_HDRS}
)

add_library(${PROJECT_NAME} OBJECT ${SRC})
if (WIN32)
	target_compile_definitions(
		${PROJECT_NAME} PRIVATE
		strdup=_strdup
		strcasecmp=_stricmp
		strncasecmp=_strnicmp
	)
endif ()

=== src/module/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,6 @@
 	proto/opentelemetry_common.proto
 	proto/opentelemetry_resource.proto
 	proto/opentelemetry_trace.proto
-	proto/opentelemetry_trace_service.proto
 	proto/opentelemetry_metrics.proto
 	proto/opentelemetry_metrics_service.proto)
 
@@ -15,6 +14,8 @@
 
 set(SRC
 	rpc_module.cc
+	rpc_trace_module.cc
+	rpc_metrics_module.cc
 	rpc_trace_filter.cc
 	rpc_metrics_filter.cc
 	${PROTO_SRCS} ${PROTO_HDRS}
@@ -22,3 +23,12 @@
 
 add_library(${PROJECT_NAME} OBJECT ${SRC})
 
+if (WIN32)
+	target_compile_definitions(
+		${PROJECT_NAME} PRIVATE
+		strdup=_strdup
+		strcasecmp=_stricmp
+		strncasecmp=_strnicmp
+	)
+endif ()
+

=== src/thrift/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(thrift)

set(SRC
	rpc_thrift_buffer.cc
	rpc_thrift_idl.cc
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== tools/templates/common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(%s LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_BUILD_TYPE RelWithDebInfo)

# Find all the dependencies
find_package(OpenSSL REQUIRED)
set(Workflow_DIR "%s")
find_package(Workflow REQUIRED CONFIG HINTS ${Workflow_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

# Prefer to static link first
set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ${CMAKE_FIND_LIBRARY_SUFFIXES})
find_library(Workflow_LIB workflow HINTS ${Workflow_DIR}/_lib)

# Set all the libraries here
set(LIB ${Workflow_LIB} pthread OpenSSL::SSL OpenSSL::Crypto)

# Add all the common codes here
set(COMMON_CODE config/config.cc config/Json.cc%s)

# Add header directories and library directories here
include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
link_directories(${OPENSSL_LINK_DIR} ${WORKFLOW_LIB_DIR})

# Build executable outputs
set(PROJECT_OUTPUT server%s)
foreach(output ${PROJECT_OUTPUT})
    add_executable(${output} ${output}_main.cc ${COMMON_CODE})
    target_link_libraries(${output} ${LIB})
endforeach()

=== tools/templates/rpc/CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
 
 add_custom_target(SRPC_GEN ALL
     COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/${IDL_FILE} ${PROJECT_SOURCE_DIR} -s
-    COMMENT "sprc generator..."
+    COMMENT "srpc generator..."
 )
 
 # Prefer to static link first

=== debian/changelog ===
srpc (0.10.3-3) unstable; urgency=medium

  * d/patches: Fix FTBFS with gtest (Closes: #1114396)
  * d/control: Standards-Version: 4.7.2
  * d/patches: Fix Last-Update format for DEP-3
  * d/copyright: Update copyright to 2025 for debian files

 -- Lance Lin <lq27267@gmail.com>  Mon, 15 Sep 2025 20:56:11 +0700

srpc (0.10.3-2) unstable; urgency=medium

  * d/patches: Enable build tests.
  * d/patches: Enables hardening for build tests.
  * d/clean: Remove build artifacts generated from tests.
  * d/tests: Enable build tests in autopkgtest.

 -- Lance Lin <lq27267@gmail.com>  Tue, 03 Sep 2024 21:32:51 +0700

srpc (0.10.3-1) unstable; urgency=medium

  * New upstream version

 -- Lance Lin <lq27267@gmail.com>  Fri, 07 Jun 2024 20:14:37 +0700

srpc (0.10.2-2) unstable; urgency=medium

  * d/patches: Fix ambiguous call to overloaded function by creating
    an instance of the function (Closes: #1071365)

 -- Lance Lin <lq27267@gmail.com>  Fri, 24 May 2024 19:23:58 +0700

srpc (0.10.2-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)

 -- Lance Lin <lq27267@gmail.com>  Thu, 25 Apr 2024 22:37:28 +0700

srpc (0.10.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062923

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:26:31 +0000

=== debian/control ===
--- 
+++ 
@@ -2,27 +2,29 @@
 Maintainer: Lance Lin <lq27267@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: cmake,
+Build-Depends: dpkg-dev (>= 1.22.5), cmake,
                debhelper-compat (= 13),
                libworkflow-dev,
                libssl-dev,
+               libgtest-dev,
                libsnappy-dev,
                libprotobuf-dev,
                protobuf-compiler,
                liblz4-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/srpc
 Vcs-Git: https://salsa.debian.org/debian/srpc.git
 Homepage: https://github.com/sogou/srpc
 Rules-Requires-Root: no
 
-Package: libsrpc0
+Package: libsrpc0t64
+Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
-Breaks: libsrpc (<< 0.9.7-1)
-Replaces: libsrpc (<< 0.9.7-1)
+Breaks: libsrpc0 (<< ${source:Version}), libsrpc (<< 0.9.7-1)
+Replaces: libsrpc0, libsrpc (<< 0.9.7-1)
 Description: Sogou RPC (SRPC) Runtime Library
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
@@ -36,7 +38,7 @@
 Package: libsrpc-dev
 Architecture: any
 Multi-Arch: same
-Depends: libsrpc0 (= ${binary:Version}),
+Depends: libsrpc0t64 (= ${binary:Version}),
          libsrpc-bin (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/srpc-$1\.tar\.gz/ \
  https://github.com/sogou/srpc/tags .*/v?(\d\S+)\.tar\.gz
